<?php
    require(PATHSERVER.'/models/curl.php');
    
    class BsaleDAL extends CURL {
        private $urlAPI = 'https://api.bsale.cl';
//        private $token = '1b7908fa44b56ba04a3459db5bb6e9b12bb9fadc'; // Token EMT //
        private $token = '689107b9a4417fe6d45dd46abadaff69b145c039'; //Token NEWTREE
        private $thirdList = '/v1/third_party_documents.json';
        private $thirdListCount = '/v1/third_party_documents/count.json';
        private $reception = '/v1/stocks/receptions.json';
        private $variant = '/v1/variants.json';
        private $products = '/v1/products.json';
        private $productsTypes = '/v1/product_types.json';
        private $documents = '/v1/documents.json';
        
        private $limitRequest = 50;
        
        public function getThirdListDAL(){
            $url = $this->urlAPI.$this->thirdList;
            return $this->getDataAPI($url, $this->token);
        }
        public function getThirdListDateDAL($year,$month){
            $countDocument = $this->countThirdListDateDAL($year, $month); $limit = $this->limitRequest;
            $qtyRequest = ceil($countDocument['count'] / $limit); $info = $countDocument['items'];
            for($x = 1; $x <= $qtyRequest; $x++){
                $dateQ = '?limit='.$limit.'&offset='.($limit * $x).'&year='.$year.'&month='.$month;
                $url = $this->urlAPI.$this->thirdList.$dateQ;
                $info = array_merge($info, $this->getDataAPI($url, $this->token)['items']);
            }
            return $info;
        }
        private function countThirdListDateDAL($year,$month){
            $dateQ = '?limit='.$this->limitRequest.'&year='.$year.'&month='.$month;
            $url = $this->urlAPI.$this->thirdList.$dateQ;
            return $this->getDataAPI($url, $this->token);
        }
        public function postDataDAL($type,$data){
            $url = $this->urlAPI.$this->selectURL($type);
            return $this->postDataAPI($url, $this->token, $data);
        }
        public function putDataDAL($type,$data){
            $url = $this->urlAPI.$type;
            echo $url;
            return $this->putInfo($url, $this->token, $data);
//            return $this->putDataAPI($url, $this->token, $data);
        }
        public function getDataDAL($type){
            $urlReq = $this->selectURL($type);
            $url = $this->urlAPI.$urlReq;
            return $this->getDataAPI($url, $this->token);
        } 
        public function getDataListDAL($type){
            $countData = $this->getDataDAL($type); $limit = $this->limitRequest;
            $qtyRequest = ceil($countData['count'] / $limit); $info = $countData['items'];
            for($x = 1; $x <= $qtyRequest; $x++){
                $dataQ = '?limit='.$limit.'&offset='.($limit * $x);
                $url = $this->urlAPI.$this->selectURL($type).$dataQ;
                $info = array_merge($info, $this->getDataAPI($url, $this->token)['items']);
            }
            return $info;
        }
        public function selectURL($type){
            switch ($type) {
                case "receptionPost": $url = $this->reception;
                    break;
                case "variantPost" : $url = $this->variant;
                    break;
                case "productsGET" : $url = $this->products;
                    break;
                case "productsTypesGET" : $url = $this->productsTypes;
                    break;
                case "documentPOST" : $url = $this->documents;
                    break;
                case "productPricePUT" : $url = $this->documents;
                    break;
                case "documentPOST" : $url = $this->documents;
                    break;
//                default: $url = $type;
//                    break;
            }   
            return $url;
        }
        
    }
