$(document).ready(function() {
    $.ajax({
      url: '../controllers/manufacturers/manufacturer.php',
      success:function(data,textStatus,jqXHR){
        let children = jQuery.parseJSON(data);
        $('#cbSupplier').select2({
          data: children.data,
          allowClear: true
        }); 
      },
      error:function(jqXHR,textStatus,errorThrown){

      }
   });
  $('#tbLineDocument').DataTable({
       ajax: '../views/invoices/line-document.php',
       columns :[
           { data: 'item'},
           { data: 'model'},
           { data: 'sku'},
           { data: 'qty'},
           { data: 'cost'},
           { data: 'codeBar'},
           { data: 'dcto'},
           { data: 'subtotal'},
           { data: 'delivery'},
           { data: 'check'}
       ],
       pageLength: 25,
       responsive: false,
       paging: true,
       searching: true,
       ordering: true,
       info: true,
       lengthChange: false,
       autoWidth: false
   });
//let data = $('#tbLineDocument').DataTable({
//                 ajax: '../views/invoices/line-document.php',
//                columns: [
//                    { data: 'item' },
//                    { data: 'sku' },
//                    { data: 'qty' },
//                    { data: 'cost' },
//                    { data: 'codeBar' },
//                    { data: 'dcto' },
//                    { data: 'subtotal' },
//                    { data: 'delivery' },
//                    { data: 'check' }
//                ],
//                pageLength: 25,
//                responsive: true,
//                paging: true,
//                searching: true,
//                ordering: true,
//                info: true,
//                lengthChange: true,
//                autoWidth: false,
//                rowGroup: {
//                    dataSrc: 'item', // Agrupar por la columna de ítem
//                    startRender: function (rows, group) {
//                        // Crear una fila de resumen
//                        let totalQty = rows.nodes().to$().find('td:eq(2)').map(function () {
//                            return parseFloat($(this).text()) || 0;
//                        }).get().reduce(function (a, b) {
//                            return a + b;
//                        }, 0);
//
//                        return $('<tr/>')
//                            .append('<td colspan="9" class="group-summary">Resumen para ' + group + ' - Total Qty: ' + totalQty + '</td>');
//                    }
//                }
//            });

    $('#tbProducts').DataTable({
       ajax: '../views/invoices/list-products.php',
       columns :[
           { data: 'addButton'},
           { data: 'imgThumbs'},
           { data: 'sku'},
           { data: 'prefixed'},
           { data: 'nameProduct'},
           { data: 'brands'},
           { data: 'codebar'},
//           { data: 'idERP'},
           { data: 'lastPrice'},
//           { data: 'codebar'},
//           { data: 'codebar'},
//           { data: 'codebar'}
       ],
       pageLength: 25,
       responsive: true,
       paging: true,
       searching: true,
       ordering: true,
       info: true,
       lengthChange: true,
       autoWidth: false
   });
});

function clean(){
    $('.fInvoice').each( function() {
        $(this).val('');
        $(this).text('');
    });
}

function addToLine(idERP,sku,model,idPro){
    let find = findId(idERP);
    $('.itemSku').each( function(){      
        if($(this).val() == 0 && find == 0){
            let id = $(this).attr('pos');
            $('#btn_'+id).text(sku);
            $('#model_'+id).text(model);
            $(this).attr('sku',sku);
            $(this).attr('idPro',idPro);
            $(this).val(idERP);
            
            return false;
        }
    });
}

function deleteItem(id){
    $('#btn_'+id).text('');
    $('#addSku_'+id).attr('sku','');
    $('#addSku_'+id).val(0);
    $('#model_'+id).text('');
    return;
}

function findId(id){
    let resp = 0;
     $('.itemSku').each( function(){
        if($(this).val() == id){
            resp = 1;
        } 
     });
     return resp;
}

function saveDoc(type){
    let supplier = $('#cbSupplier').val();
    let supplierName = $('select[id="cbSupplier"] option:selected').text();
    let typeDocument = $('#cbTypeDocument').val();
    let nDocument = $('#nDocument').val();
    let dcto = $('#dctoGeneral').val();
    let datePurchase = $('#datePurchase').val();
    let dateExpired = $('#dateExpired').val();
    let observation = $('#observation').val();
    let typePay = $('#cbTypePay').val();
    let nCheque = $('#nCheque').val();
    let qtyCheque = $('#qtyCheque').val();
    let subtotal = $('#subtotal').val();
    let urlPDF = $('#urlPDF').val();
    let details = []; let qty; let cost; let codeBar; let dctoItem; let subtotalItem; let deliveryItem; let checkItem; let sku; let idERP;
    $('.itemSku').each( function(){      
        if($(this).val() > 0){
            pos = $(this).attr('pos');
            qty = $('#qty_'+pos).val();
            cost = $('#cost_'+pos).val();
            codeBar = $('#codeBar_'+pos).val();
            dctoItem = $('#dcto_'+pos).val();
            subtotalItem = $('#subtotal_'+pos).val();
            deliveryItem = $('#delivery_'+pos).val();
            checkItem = $('#deliveryTotal_'+pos).prop('checked');
            sku = $(this).attr('sku');
            model = $('#model_'+pos).text();
            codProv = $('#addSku_'+pos).attr('codprovider');
            idERP = $(this).val();
            idPro = $(this).attr('idPro');
            data = { qty: qty,cost:cost,codeBar:codeBar,dctoItem:dctoItem, subtotalItem: subtotalItem, deliveryItem:deliveryItem, checkItem:checkItem, sku:sku,idERP:idERP,model:model,codProv:codProv,idPro:idPro };
            details.push(data);
        }
    });
    let headers = { supplier: supplier, supplierName:supplierName, typeDocument:typeDocument, nDocument:nDocument, dcto:dcto, datePurchase:datePurchase, dateExpired:dateExpired, observation:observation, typePay:typePay, nCheque:nCheque, qtyCheque:qtyCheque, subtotal:subtotal,urlPDF:urlPDF };
    let info = { headers: headers, details:details, type:type };
      Swal.fire({
            title: '¿Estás seguro?',
            text: "Esta acción no se puede deshacer",
            icon: 'warning',
            showCancelButton: true,
            confirmButtonText: 'Sí',
            cancelButtonText: 'No'
        }).then((result) => {
            if (result.isConfirmed) {
                    $.ajax({
                    url:'../controllers/invoices/add-purchase.php',
                    type: 'POST',
                    data: info,
                    success:function(data){

                    },
                    error:function(){

                    }
                });
            } else if (result.dismiss === Swal.DismissReason.cancel) {

            }
        });

}
function qrCodeMake(url){
  var typeNumber = 10;
  var errorCorrectionLevel = 'H';
  var qr = qrcode(typeNumber, errorCorrectionLevel);
  qr.addData(url);
  qr.make();
//  document.getElementById('imgQR').innerHTML = qr.createImgTag(); 
  let opts = { }
  document.getElementById('imgQR').innerHTML = qr.createSvgTag(8,8,true);
}
function showQRFactura(){
    let path = 'emterpcl.cl'; let rut = $('#cbSupplier').val(); let typeDocument = $('#cbTypeDocument').val(); let nDocument = $('#nDocument').val();
    let url = 'https://'+path+'/public/agregar-photo.php?rut='+rut+'&type='+typeDocument+'&number='+nDocument;
    qrCodeMake(url);
    let qr = document.getElementById("imgQR").querySelector("svg");
    $('#modalQR').modal('show');
}

function downloadDocument(mes){
    $.ajax({ 
        url: '../controllers/invoices/invoices-erp.php',
        type:'POST',
        data:{ mes: mes },
        success:function(){
            
        },
        error:function(){
            
        }
    })
}

function loadDraft(){
   let supplier = $('#cbSupplier').val();
   let typeDocument = $('#cbTypeDocument').val();
   let nDocument = $('#nDocument').val();
   $.ajax({
       url: '../controllers/invoices/load-draft.php',
       type:'POST',
       data:{ supplier:supplier, typeDocument:typeDocument,nDocument:nDocument },
       success:function(data,textStatus,jqXHR){
           var data = jQuery.parseJSON(data);
            $('#cbSupplier').val(data.headers.supplier);
            $('select[id="cbSupplier"] option:selected').text(data.headers.supplierName);
            $('#cbTypeDocument').val(data.headers.typeDocument);
            $('#nDocument').val(data.headers.nDocument);
            $('#dctoGeneral').val(data.headers.dcto);
            $('#datePurchase').val(data.headers.datePurchase);
            $('#dateExpired').val(data.headers.dateExpired);
            $('#observation').val(data.headers.observation);
            $('#cbTypePay').val(data.headers.typePay);
            $('#nCheque').val(data.headers.nCheque);
            $('#qtyCheque').val(data.headers.qtyCheque);
            $('#subtotal').val(data.headers.subtotal);
            $('#urlPDF').val(data.headers.urlPDF);
            let item = data.details;
            console.log(item);
            item.forEach( function(item , pos){    
                $('#qty_'+pos).val(item.qty);
                $('#cost_'+pos).val(item.cost);
                $('#codeBar_'+pos).val(item.codeBar);
                $('#dcto_'+pos).val(item.dctoItem);
                $('#subtotal_'+pos).val(item.subtotalItem);
                $('#delivery_'+pos).val(item.deliveryItem);
                $('#btn_'+pos).text(item.sku);
                $('#addSku_'+pos).val(item.idERP);
                $('#addSku_'+pos).attr('sku',item.sku);
                $('#model_'+pos).text(item.model);  
                $('#addSku_'+pos).attr('codprovider',item.codProv);
                let isChecked = (item.checkItem === 'true' || item.checkItem === true);
                $('#deliveryTotal_' + pos).prop('checked', isChecked);
//                sku = $(this).attr('sku');
//                idERP = $(this).val();
            });
       },
       error:function(jqXHR,textStatus,errorThrown){
            
       }
   });
}

function loadXML(){
   clean();
    let supplier = $('#cbSupplier').val();
    let nDocument = $('#nDocument').val();
    $.ajax({
       url: '../controllers/invoices/load-xml.php',
       type:'POST',
       data: { supplier:supplier, nDocument:nDocument },
       success:function(data,textStatus,jqXHR){
           var data = jQuery.parseJSON(data);
           $('#datePurchase').val(data.emissionDate);
           $('#dateExpired').val(data.expiredDate);
           $('#subtotal').val(data.totalNetoDoc);
           $('#dctoGeneral').val(data.globalDcto);
           $('#urlPDF').val(data.urlPDF);
           let details = data.data;
           details.forEach( function(item, index){
               $('#qty_'+index).val(parseInt(item.QtyItem));
               $('#cost_'+index).val(parseInt(item.PrcItem));
               $('#subtotal_'+index).val(parseInt(item.MontoItem));
               $('#model_'+index).text((cleanUTF8String(item.NmbItem)));  
               if(typeof item['CdgItem'] === 'undefined'){}
               else if(typeof item['CdgItem']['VlrCodigo'] !== 'undefined'){
                   $('#addSku_'+index).attr('codProvider',item['CdgItem']['VlrCodigo']);
               }  
           });
       },
       error:function(){
           
       }
    });
}
function cleanUTF8String(str) {
    return str.replace(/[^\x20-\x7E]/g, '');
}

function getDataProducts_ERP(){
    $('#modalNewProduct').modal('show');
     $.ajax({
      url: '../controllers/products/get-products.php?type=1',
      success:function(data,textStatus,jqXHR){
        let info = jQuery.parseJSON(data);
        $('#cbtypeProducts').select2({
          data: info.data,
          dropdownParent: $('#modalNewProduct .modal-content'),
          allowClear: true
        });
      },
      error:function(jqXHR,textStatus,errorThrown){

      }
   });
}
$('#cbtypeProducts').on('change',function(){
    getProductsERP($(this).val());
})
function getProductsERP(id){
    $('#cbProducts').empty();
     $.ajax({
      url: '../controllers/products/get-products.php?type=2&id='+id,
      success:function(data,textStatus,jqXHR){
        let info = jQuery.parseJSON(data);
        $('#cbProducts').select2({
          data: info.data,
          dropdownParent: $('#modalNewProduct .modal-content'),
          allowClear: true
        }); 
      },
      error:function(jqXHR,textStatus,errorThrown){

      }
   });
}
function makeCodeBar(){
    let val = getRandomInt(10000000000000,99999999999999);
   $('#txtCodeBar').val(val); 
}

function getRandomInt(min, max) {
    // Ensure the min and max are integers
    min = Math.ceil(min);
    max = Math.floor(max);
    // Return a random integer between min (inclusive) and max (inclusive)
    return Math.floor(Math.random() * (max - min + 1)) + min;
}
function saveProduct(){
    let model = $('#txtModel').val();
    let alias = $('#txtAlias').val();
    let brand = $('#txtManufacturer').val();
    let codeBar = $('#txtCodeBar').val();
    let typeProduct = $('#cbtypeProducts').val();
    let product = $('#cbProducts').val();
    let printLabel = $('#cbPrintLabel').val();
    $.ajax({
        url:'../controllers/products/add-product.php',
        type:'POST',
        data: { nameProduct:model, prefixed:alias, brands:brand, codeBar:codeBar, typeProduct:typeProduct, product:product, printLabel:printLabel },
        success:function(data,textStatus,jqXHR){
            var data = jQuery.parseJSON(data);
            if(data.resp == 1){
                $('.npro').each(function(){
                   $(this).val(''); 
                });
                $('#modalNewProduct').modal('hide');
                Swal.fire('Agregado','Producto agregado con exito','success');
                var tb = $('#tbProducts').DataTable();
                tb.ajax.reload();
            }
            
        },
        error:function(jqXHR,textStatus,errorThrown){
            
        }
    })
}