$(document).ready(function() {
   let id = $('#idInvoice').val();
   $('#tbProcessPurchase').DataTable({
       ajax: {
            url: '../views/invoices/get-process-invoice.php',
            type:'POST',
            data:{ id: id},
       },
       columns :[
           { data: 'item'},
           { data: 'sku'},
           { data: 'productName'},
           { data: 'qty'},
           { data: 'stock'},
           { data: 'cost'},
           { data: 'costDcto'},
           { data: 'costTeoric'},
           { data: 'lastCost'},
           { data: 'pricePonderateAvg'},
           { data: 'total'},
           { data: 'logPrice'},
           { data: 'mainPrice'},
           { data: 'offerPrice'},
           { data: 'manualPrice'},
           { data: 'goToWeb'},
           { data: 'requestPublish'}
       ],
       pageLength: 25,
       responsive: true,
       paging: true,
       searching: true,
       ordering: true,
       info: true,
       lengthChange: true,
       autoWidth: false
   });
   $.ajax({
       url : '../views/invoices/get-header-invoice.php',
       type: 'POST',
       data: { id:id },
       success:function(data,textStatus,jqXHR){
           var data = jQuery.parseJSON(data);
           $('#payMethod').text(data.headers.typePay);
           $('#nCheque').text(data.headers.nCheque);
           $('#datePay').text(data.headers.datePurchase);
           $('#userProcess').text(data.headers.userProcess);
           $('#statusInvoice').text(data.headers.statusInvoice);
           
           $('#typeDoc').text(data.headers.typeDocument);
           $('#nDocument').text(data.headers.nDocument);
           $('#supplier').text(data.headers.supplierName)
           
           $('#dateAdd').text(data.headers.dateAdd);
           $('#dateEmision').text(data.headers.datePurchase);
           $('#dateReception').text(data.headers.dateReception);
           $('#dctoDocument').text(data.headers.dcto);
           $('#subtotalNeto').text(data.headers.subtotalNeto);
           $('#subtotalBruto').text(data.headers.subtotalBruto);
           $('#statusInvoice').addClass(data.headers.statusCss);
           $('#btnPdf').attr('urlPdf',data.headers.urlPDF);
           $('#imgInvoice').prop('src',data.headers.imgInvoice);
           
           $('#observationStatus').text(data.headers.observation);
       },
       error:function(jqXHR,textStatus,errorThrown){
           
       }
   });
});

function dismissInvoice(id){
    $.ajax({
        url: '../controllers/invoices/dismiss-invoice.php',
        type: 'POST',
        data: {id:id},
        success:function(data,textStatus,jqXHR){
            let d = $('#tbListReception').DataTable();
            d.ajax.reload();
        }
    })
}

function viewPDF(){
    let url = $('#btnPdf').attr('urlPdf');
    var popupWidth = 800;
    var popupHeight = 1000;
    var left = (screen.width / 2) - (popupWidth / 2);
    var top = (screen.height / 2) - (popupHeight / 2);
    window.open(
         url, // URL de la página que quieres abrir en el popup
         'Documento', // Nombre de la ventana
         'width=' + popupWidth + ', height=' + popupHeight + ', top=' + top + ', left=' + left
    );
}

function showImage(){
    let src = $('#imgInvoice').attr('src');
    $('#imageGrant').html('<img src="'+src+'" />');
    $('#showImage').modal('show');
}

function changePrice(id, idERP,sku,type){
    let bPrice = $('#bPrice_'+id).val();
    let oPrice = $('#oPrice_'+id).val();
    let mPrice = $('#mPrice_'+id).val();
    $.ajax({
       url:'../controllers/products/update-price.php',
       type:'POST',
       data: { idERP:idERP, sku:sku, type:type , bPrice:bPrice, oPrice:oPrice, mPrice:mPrice },
       success:function(data,textStatus,jqXHR){
           
       },
       error:function(jqXHR,textStatus,errorThrown){
           
       }
    });
}

function accepInvoice(id){
    $.ajax({
        url: '../controllers/invoices/upload-document.php',
        type: 'POST',
        data: {id:id},
        success:function(data,textStatus,jqXHR){
           
        }
    })
}